<template>
    <div class="text-center">
        <v-dialog v-model="dialog" width="650" v-if="isCurrentUserAllowed" ref="dialog">
            <template v-slot:activator="{ on, attrs }">
                <v-btn v-bind="attrs" v-on="on" icon>
                    <v-icon color="red">
                        mdi-delete
                    </v-icon>
                </v-btn>
            </template>
            <v-card>
                <v-card-title class="headline red">
                    <span class="headline white--text">{{ $t('Task.LNG_TASK_DELETE') }}</span>
                    <v-spacer></v-spacer>
                    <v-btn color="error" @click="closeDialog" fab small>
                        <v-icon color="white">mdi-close</v-icon>
                    </v-btn>
                </v-card-title>
                <v-card-text>
                    <p style="font-size: 1.2em" class="pt-3 mb-n2">{{ $t('Task.LNG_TASK_DELETE_QUESTION') }}</p>
                </v-card-text>
                <v-card-actions class="px-3">
                    <v-spacer></v-spacer>
                    <v-btn @click="closeDialog" color="grey" class="mr-4 white--text">
                        {{ $t('Task.LNG_TASK_DELETE_CANCEL') }}
                    </v-btn>
                    <v-btn @click="deleteLesson" color="error" class="mr-4">
                        {{ $t('Task.LNG_TASK_DELETE') }}
                    </v-btn>
                </v-card-actions>
                <v-card-text>
                    <p v-if="requestOK || requestFail"
                       :style="{ color: (requestOK) ? 'green' : 'red'}"
                       class="mt-1 mb-n2 text-right">
                        {{ message }}
                    </p>
                </v-card-text>
            </v-card>
        </v-dialog>
    </div>
</template>

<script>
import Services from "@/services/api"
import { mapGetters } from "vuex";

export default {
    name: 'TaskDelete',
    props: {
        taskId: {
            required: true
        }
    },
    data: () => ({
        dialog: false,
        requestOK: false,
        requestFail: false,
        message: ""
    }),
    computed: {
        ...mapGetters([
            'user',
        ]),
        isCurrentUserAllowed() {
            return this.user && (this.user.type === 'TEACHER' || this.user.type === 'ADMIN');
        }
    },
    methods: {
        deleteLesson() {
            // Delete the current task using API and its ID
            Services.Task.deleteTask(this.taskId)
                .then(res => {
                    // Manage returned HTTP code
                    this.manageHTTPCodeReturned(res.status);
                })
        },
        // Display a message for the user with the returned HTTP code
        manageHTTPCodeReturned(code) {
            this.requestOK = false;
            this.requestFail = false;
            switch (code) {
                case 200:
                    this.requestOK = true;
                    this.message = this.$t("Task.LNG_TASK_DELETE_DELETED");
                    setTimeout(() => {
                        this.$emit("deleted");
                        this.closeDialog();
                    }, 3000);
                    break;
                case 404:
                    this.requestFail = true;
                    this.message = this.$t("Task.LNG_TASK_DELETE_404");
                    break;
                default:
                    if (code >= 400 && code < 500) {
                        this.requestFail = true;
                        this.message = this.$t("Task.LNG_TASK_DELETE_CLIENTERROR") + " Code : " + code;
                    } else if (code >= 500 && code < 600) {
                        this.requestFail = true;
                        this.message = this.$t("Task.LNG_TASK_DELETE_SERVERERROR") + " Code : " + code;
                    } else {
                        this.requestFail = true;
                        this.message = this.$t("Task.LNG_TASK_DELETE_FAILED") + " Code : " + code
                    }
            }
        },
        closeDialog() {
            this.dialog = false;
            this.requestOK = false;
            this.requestFail = false;
            this.message = "";
        }
    }
}
</script>
